import os, os.path
from conf import *

Import('conf vars')

# Options
def globDefault(glob):
    paths = Glob(glob)

    if len(paths) == 0:
        return None
    else:
        return paths[0]

cplex_include = globDefault('/usr/ilog/cplex*/include')
cplex_lib = globDefault('/usr/ilog/cplex*/lib/*/static_pic')

vars.add(BoolVariable('WITH_CPLEX', 'Use CPLEX for optimization',
                      cplex_include != None and cplex_lib != None))

if vars['WITH_CPLEX']:
    vars.add(PathVariable('CPLEX_INCLUDE', 'C include directory for CPLEX',
                          cplex_include,
                          PathVariable.PathIsDir))
    vars.add(PathVariable('CPLEX_LIBDIR', 'lib directory for CPLEX',
                          cplex_lib,
                          PathVariable.PathIsDir))

    # CPLEX options
    conf.env.AppendUnique(LIBPATH = ['$CPLEX_LIBDIR'])
    conf.env.AppendUnique(CPPPATH = ['$CPLEX_INCLUDE'])

    require.LibWithHeader(conf, 'cplex', 'ilcplex/cplex.h')

    conf.env.AppendUnique(LIBS = ['cplex'])
    conf.env.AppendUnique(CPPDEFINES = ['WITH_CPLEX'])
