from conf import *

Import('conf')

libjpeg_test_source_file = """
#include <stdlib.h>
#include <stdio.h>
#include <jpeglib.h>

int main(int argc, char **argv)
{
  struct jpeg_decompress_struct cinfo;

  jpeg_create_decompress(&cinfo);
  jpeg_destroy_decompress(&cinfo);

  return 0;
}
"""

def CheckLibJpeg(context):
    old_libs = conf.env['LIBS']

    try:
        conf.env.Append(LIBS = ['jpeg'])

        context.Message('Checking for libjpeg...')
        result = context.TryLink(libjpeg_test_source_file, '.c')
        context.Result(result)
    finally:
        conf.env['LIBS'] = old_libs

    return result

conf.AddTest('CheckLibJpeg', CheckLibJpeg)

if not conf.CheckLibJpeg():
    print('libjpeg is required')
    Exit(1)

conf.env.AppendUnique(LIBS = ['jpeg'])
