import os, os.path
from conf import *

Import('conf vars')

vars.add(BoolVariable('WITH_NIFTI', 'Allow reading tensors from NIfTI files using nifticlib', True))

if vars['WITH_NIFTI']:
    vars.add(PathVariable('NIFTI_ROOT', 'Root directory for niftilib',
                          '/usr/', PathVariable.PathIsDir))

    vars.add(PathVariable('NIFTI_INCLUDE', 'Include directory for niftilib',
                          os.path.join(vars['NIFTI_ROOT'], 'include/'),
                          PathVariable.PathIsDir))
    vars.add(PathVariable('NIFTI_LIBDIR', 'lib directory for CPLEX',
                          os.path.join(vars['NIFTI_ROOT'], 'lib/'),
                          PathVariable.PathIsDir))

    
    conf.env.AppendUnique(CPPPATH = ['$NIFTI_INCLUDE'])

    conf.env.AppendUnique(LIBPATH = ['$NIFTI_LIBDIR'])
    conf.env.AppendUnique(LIBS = ['niftiio', 'znz', 'z'])

    conf.env.AppendUnique(CPPDEFINES = ['WITH_NIFTI'])

    require.CHeader(conf, 'nifti1_io.h')
    require.Lib(conf, 'niftiio')
    require.Lib(conf, 'znz')
    require.Lib(conf, 'z')
