#!/bin/sh

# Generate figures
cd figs
scons
cd ..

# Generate bibtex
pdflatex accv2010
bibtex accv2010

# Generate tex sources and PDF
scons -c
scons accv2010-monolith.tex accv2010-monolith.pdf

# Create zip
DIR='accv2010-558-camera-ready'
mkdir $DIR

cp accv2010-monolith.tex $DIR/$DIR.tex
cp accv2010-monolith.pdf $DIR/$DIR.pdf
cp copyrightlncs.png $DIR

cp llncs.cls $DIR
cp splncs.bst $DIR

cp -r figs $DIR
cd $DIR/figs
rm -rf .svn anatomy/.svn *.log *.aux
cd ../..

ZIP="${DIR}.zip"
rm $ZIP
zip -r $ZIP $DIR

rm -rf $DIR