import sys
from random import random
from math import *
from vector import *
from tensor import *

def randomVector(dim):
    return Vector(dim, [random() for i in range(dim)])

def randomTensor(dim, mag_max = 1.0, mag_min = 0.1):
    """ Generate a random tensor. """

    # Create a basis of random orthogonal vectors
    vectors = []

    for i in range(dim):
        v = randomVector(dim).unitVector()

        for u in vectors:
            v -= u * v.dot(u)

        v = v.unitVector()

        vectors.append(v)

    # Add the dyadic tensors of these vectors
    T = Tensor(dim)

    for v in vectors:
        T += dyadicTensor(v * (random() * (mag_max - mag_min) + mag_min))

    return T


if __name__ == '__main__':

    USAGE = """random_tensor.py <dim>"""
    
    try:
        dim = int(sys.argv[1])
    except:
        print USAGE
        exit(1)
    T = randomTensor(dim)
    print str(T)
