import sys
from math import *
from tensor import *
from random_tensor import *

def createGrid(size, origin, delta):
    points = [[i*delta[0] + origin[0]] for i in range(size[0])]
    for d in range(1,dim):
        new_points = []
    
        for i in range(size[d]):
            for p in points:
                new_points.append(p + [i*delta[d] + origin[d]])

        points = new_points

    return points

def printPoint(p):
    s = '(%f' % p[0]
    for x in p[1:]:
        s += ', %f' % x
    s += ')'

    print s
        
if __name__ == '__main__':
    # Parse arguments
    USAGE = """random_tensor_field.py <dim> <size> <origin> <grid_delta>"""

    try:
        dim = int(sys.argv[1])

        def xvector(type, s):
            v = s.split('x')
            v = [type(x) for x in v]

            if len(v) != dim:
                raise 1

            return v

        size = xvector(int, sys.argv[2])
        origin = xvector(float, sys.argv[3])
        delta = xvector(float, sys.argv[4])
    except:
        print USAGE
        exit(1)

    points = createGrid(size, origin, delta)


    # TODO: create the tensors + output them in C-readable format
    for p in points:
        T = randomTensor(dim)

        printPoint(p)
        print str(T)
        print ''
    
