from math import *
from vector import *

import Numeric
#import Numeric.LinearAlgebra

class Tensor:
    def __init__(self, dim, init = False):
        if not init:
            init = [[0]*dim for i in range(dim)]

        self.T = init

    def __getitem__(self, i):
        return self.T[i]

    def dim(self):
        return len(self.T)

    def __mul__(A, s):
        n = A.dim()
        P = Tensor(n)

        for i in range(n):
            for j in range(n):
                P[i][j] = A[i][j] * s

        return P

    def __add__(A, B):
        n = A.dim()
        S = Tensor(n)

        for i in range(n):
            for j in range(n):
                S[i][j] = A[i][j] + B[i][j]

        return S

    def __str__(self):
        """ Prints a tensor in the ASCII upper-triangular format """

        lines = [''] * self.dim()

        def align():
            L = max([len(s) for s in lines])

            for i in range(self.dim()):
                lines[i] += ' ' * (L - len(lines[i]))

        lines[0] = '['
        align()

        for j in range(self.dim()):
            for i in range(j+1):
                lines[i] += '%f' % self[i][j]

            if j != self.dim() - 1:
                for i in range(j+1):
                    lines[i] += ', '

            align()

        for i in range(self.dim()-1):
            lines[i] += ';'
        lines[-1] += ']'

        return '\n'.join(lines)

def dyadicTensor(v):
    n = len(v)
    T = Tensor(n)

    for i in range(n):
        for j in range(n):
            T[i][j] = v[i] * v[j]

    return T


def ballTensor(dim, scale):
    T = Tensor(dim)

    for i in range(dim):
        T[i][i] = scale

    return T
