from math import *

class Vector:
    def __init__(self, dim, init = False):
        if not init:
            init = [0]*dim

        self.v = init

    def magnitude(self):
        return sqrt(sum([x*x for x in self.v]))

    def unitVector(self):
        return self/self.magnitude()

    def __len__(self):
        return len(self.v)

    def dim(self):
        return len(self)

    def __iter__(self):
        return self.v.__iter__()

    def __getitem__(self, i):
        return self.v[i]

    def __setitem__(self, i, v):
        self.v[i] = v

    def __add__(A, B):
        S = Vector(len(A))

        for i in range(len(A)):
            S[i] = A[i] + B[i]

        return S

    def __sub__(A, B):
        D = Vector(len(A))

        for i in range(len(A)):
            D[i] = A[i] - B[i]

        return D

    def __mul__(v, x):
        P = Vector(len(v))

        for i in range(len(v)):
            P[i] = v[i] * x

        return P

    def __div__(v, x):
        Q = Vector(len(v))

        for i in range(len(v)):
            Q[i] = v[i] / x

        return Q

    def dot(u, v):
        P = 0

        for i in range(len(u)):
            P += u[i] * v[i]

        return P

    def __str__(self):
        return '(' + ', '.join([str(x) for x in self.v]) + ')'
