import SCons, SCons.Script

byte_order_program = """
#include <stdio.h>

typedef union {
  int integer;
  char bytes[sizeof(int)];
} bytewise_int_t;

int main(int argc, char *argv[])
{
  bytewise_int_t i;

  i.integer = 0;
  i.bytes[0] = 1;

  printf("%u", i.integer);

  return 0;
}
"""

def CheckBigEndian(context):
  context.Message('Checking byte order... ')

  result = context.TryRun(byte_order_program, '.c')
  if result[0] != 1:
    context.Result('failed')
    SCons.Script.Exit(1)

  i = int(result[1])

  if i == 1:
      context.Result('little-endian')
      return False
  else:
      context.Result('big-endian')
      return True

def generate(conf):
  conf.AddTest('CheckBigEndian', CheckBigEndian)

