import subprocess
import re

def commandOutput(command):
    try:
        proc = subprocess.Popen(command,
                                stdout=subprocess.PIPE,
                                stderr=subprocess.STDOUT)
        out = proc.stdout.read()
        
        return out
    except:
        return None

def gccTarget():
    """Retrives the target triplet from gcc."""

    try:
        out = commandOutput(['gcc', '-v'])
        m = re.search('Target:\s+(.*?)\s+', out)

        target = m.groups()[0]
        target = target.split('-')

        # Grab just the first two parts of the target
        target = target[0] + '-' + target[1]

        return target
    except:
        return 'unknown'
