from target import Target

class Documentation(Target):
    def __init__(self, env, name, doxyfile, **kwargs):
        Target.__init__(self, env, **kwargs)

        self.name = name
        self.doxyfile = doxyfile

    def targetBasename(self):
        return self.name

    def build(self, **kwargs):
        self.doxyfile['OUTPUT_DIRECTORY'] = env.Dir(self.target())

        # Output the doxyfile proper
        f = self.target() + '.doxy'
        env.Doxyfile(f, Value(self.doxyfile))

        # Build the documentation
        self.built = env.Doxygen(f)

        if not self.internal:
            self.env.Default(self.built)
