import os, os.path
import subprocess
import sys

import SCons.Script as scons

def ext(path):
    return os.path.splitext(path)[1][1:]

ext_mapping = {'png': 'png'}

def plot(target, source, env):
    proc = subprocess.Popen(['gnuplot'], stdin = subprocess.PIPE)

    stdin = proc.stdin

    out = target[0].path
    stdin.write('set term %s\n' % ext_mapping[ext(out)])
    stdin.write('set output "%s"\n' % out)

    stdin.write('set style fill solid 0.5\n')
    stdin.write('set log y\n')
    
    stdin.write('plot "%s" using 1:2 with boxes notitle\n' % source[0].path)

    stdin.close()

    proc.wait()

def generate(env):
    builder = scons.Builder(action = plot)
    env.Append(BUILDERS = {'BarChart': builder})

def exists(env):
    return env.Detect('gnuplot')
