import urllib2

from SCons.Script import *

CHUNK_SIZE = 4096

def download(target, source, env):
    for dst, src in zip(target, source):
        # Open up files
        src = urllib2.urlopen(str(src))
        dst = file(str(dst), 'w+')

        info = src.info()
        size = 'content-length' in info and info['content-length']

        # TODO: use size to report progress
        # overwrite by using carriage return to enter
        # See Scons "Providing Build Progress Output"

        # TODO: use as scanner
        #print info['last-modified']

        # Copy files
        s = src.read(CHUNK_SIZE)
        while s != '':
            dst.write(s)
            s = src.read(CHUNK_SIZE)

        dst.close()
        src.close()


def generate(env):
    builder = env.Builder(action = download)
    env.Append(BUILDERS = {'Download': builder})

def exists(env):
    return True
