class SourceList:
    def __init__(self, env, ls = []):
        self.env = env
        self.files = set([])

        self += ls

    def __iadd__(self, f):
        if type(f) == str:
            self.files.add(self.env.File(f))
        elif type(f) == list:
            for g in f:
                self += g
        elif 'files' in vars(f):
            self.files.update(f.files)
        else:
            self.files.add(f)

        return self

    def __call__(self):
        return list(self.files)

    def __iter__(self):
        return self.files.__iter__()

    def lineCount(self):
        n = 0
        for f in self.files:
            for l in file(f.abspath).readlines():
                n += 1

        return n
