from component import Component
from target import Target
from source_list import SourceList

from SCons.Node.Python import Value
from SCons.Defaults import Mkdir

class StaticLibrary(Target):
    def __init__(self, env, name, libs = [], **kwargs):
        Target.__init__(self, env, **kwargs)

        self.name = name
        self.sublibs = SourceList([])
        self.built = False

        self += libs

    def targetBasename(self):
        s = ''

        s += self.env['LIBPREFIX']
        s += self.name
        s += self.env['LIBSUFFIX']

        return s

    def __iadd__(self, a):
        if type(a) == list:
            for b in a:
                self += b
        elif isinstance(a, StaticLibrary):
            self.sublibs += a
        else:
            Component.__iadd__(self, a)

        return self

    def build(self, **kwargs):
        env = self.env

        sources = self.sources()
        sources.sort()

        self.built = env.StaticLibrary(self.target(), sources, **kwargs)

        if not self.internal:
            self.env.Default(self.built)

