import SCons.Script

from socket import gethostname
import os, os.path


class Variables:
    def __init__(self, env):
        self.env = env

        # Load variables
        files = ['buildopts.py', '%s.py' % gethostname()]

        basedir = str(env.Dir('#'))
        files = [os.path.join(basedir, f) for f in files]

        self.vars = SCons.Script.Variables(files = files)

    def add(self, variable):
        key = variable[0]

        self.vars.Add(variable)
        self.vars.Update(self.env)

        SCons.Script.Help(self.vars.FormatVariableHelpText(self.env, key, variable[1], variable[2], self.env[key]))

    def help(self):
        #SCons.Script.Help(self.vars.GenerateHelpText(self.env))
        pass

    def __getitem__(self, k):
        if k in self.vars.keys():
            return self.env[k]

    def __iter__(self):
        for k in self.vars.keys():
            yield k

    def items(self):
        for k in self:
            yield k, self[k]
