#include "boundary.h"

mask_t *boundary(graph_t *G, mask_t *m)
{
	int i, j, n, d;
	int neighbor;
	mask_t *b;

	assert(mask_size(m) == graph_vertex_count(G));

	n = mask_size(m);
	b = mask_create(n);
	
	for(i = 0; i < n; i++) {
		mask_set(b, i, false);

		if(!mask_get(m, i)) {
			continue;
		}

		// i is in the region

		// Iterate over neighbors of i
		d = graph_vertex_degree(G, i);
		for(j = 0; j < d; j++) {
			neighbor = graph_vertex_neighbor(G, i, j);

			if(!mask_get(m, neighbor)) {
				mask_set(b, i, true);
				break;
			}
		}
	}
	
	return b;
}
