#include "connectivity.h"

matrix_list_t *connectivity_constraints(
  line_graph_t *L, flat_line_graph_t *FL,
	mask_t *endpoints,
	int alpha_offset, int gamma_offset)
{
	int vertex_count, edge_pair_count;
	int nnz;

	int i, j, a, d, row, elt;
	
	edge_pair_t *ep;

	matrix_list_t *A;

	vertex_count = flat_line_graph_vertex_count(FL);
  edge_pair_count = flat_line_graph_total_edge_pair_count(FL);

	// Count nnz
	nnz = 0;
	row = 0;
	for(i = 0; i < edge_pair_count; i++) {
    ep = &(flat_line_graph_flat_edge_pair(FG, i)->edge_pair);

		for(a = 0; a < 2; a++) {
			neighbor = ep->neighbors[a];
			if(endpoints != NULL && mask_get(endpoints, neighbor)) {
				continue;
			}

			d = flat_line_graph_edge_pair_count(FG, neighbor);

			// -\alpha_{ijk} term
			nnz++;

			for(j = 0; j < d; j++) {
				neighbor_ep = flat_line_graph_edge_pair(FG, neighbor, j);

				assert(neighbor_ep->edge_pair.common_vertex == neighbor);

				// predicate whether this edge pair shares an edge
				// with edge pair i
				if(neighbor_ep->edge_pair.neighbors[0] == ep->common_vertex
					 || neighbor_ep->edge_pair.neighbors[1] == ep->common_vertex) {

					// +\alpha_{kjl} or +\alpha_{lik} term
					nnz++;
				}
			}

			row++;
		}
	}

	matrix_list_create(rows, 2*edge_pair_count 
}
