#ifndef __FLAT_GRAPH_H__
#define __FLAT_GRAPH_H__

#include "graph.h"

typedef struct flat_graph flat_graph_t;

typedef struct {
	edge_t edge;
	int index;
} flat_edge_t;

flat_graph_t *flat_graph_create(graph_t *);
void flat_graph_destroy(flat_graph_t *);

// Accessors
int flat_graph_vertex_count(flat_graph_t *);
int flat_graph_edge_count(flat_graph_t *);

flat_edge_t *flat_graph_edge(flat_graph_t *, int i);

flat_edge_t *flat_graph_vertex_start(flat_graph_t *, int i);
int flat_graph_vertex_degree(flat_graph_t *, int i);

int flat_graph_edge_index(flat_graph_t *, int u, int v);

#endif // #ifndef __FLAT_GRAPH_H__
