#ifndef __FLAT_LINE_GRAPH_H__
#define __FLAT_LINE_GRAPH_H__

#include "line_graph.h"

// A non-mutable line graph structure in which each edge pair
// has an index.

typedef struct flat_line_graph flat_line_graph_t;

typedef struct {
  edge_pair_t edge_pair;
  int index;

} flat_edge_pair_t;

flat_line_graph_t *flat_line_graph_create(line_graph_t *);
void flat_line_graph_destroy(flat_line_graph_t *);

// Accessors
int flat_line_graph_vertex_count(flat_line_graph_t *);
int flat_line_graph_total_edge_pair_count(flat_line_graph_t *);
int flat_line_graph_max_pair_degree(flat_line_graph_t *);

int flat_line_graph_edge_pair_count(flat_line_graph_t *, int vertex);
flat_edge_pair_t *flat_line_graph_edge_pair(flat_line_graph_t *, int vertex, int i);

flat_edge_pair_t *flat_line_graph_flat_edge_pair(flat_line_graph_t *, int i);

#endif // #ifndef __FLAT_LINE_GRAPH_H__
