#ifndef __GRAPH_H__
#define __GRAPH_H__

typedef struct graph graph_t;
typedef double weight_t;

typedef struct {
	int u, v;
	weight_t weight;
} edge_t;

graph_t *graph_create(int N);
void graph_destroy(graph_t *);

// Accessors
int graph_vertex_count(graph_t *);
int graph_edge_count(graph_t *);

int graph_vertex_degree(graph_t *, int i);
edge_t graph_vertex_edge(graph_t *, int i, int j);
int graph_vertex_neighbor(graph_t *, int i, int j);
void graph_vertex_edge_set_weight(graph_t *, int i, int j, weight_t w);

void graph_edge_add(graph_t *, edge_t *);
bool graph_edge_present(graph_t *, int i, int j);

#endif // #ifndef __GRAPH_H__
