#include "grid.h"

#include "util.h"

double integrate_grid(
  int dim,
  double (*f)(void *closure_data, double *x),
  double *min, double *max,
  int *samples,
  void *closure_data)
{
  int i, j, k, l, n;
  double I, *x, V;

  x = malloc(sizeof(double) * dim);

  // Find volume and total grid points
  n = 1;
  V = 1;
  for(i = 0; i < dim; i++) {
    n *= samples[i];
    V *= max[i] - min[i];
  }

  // Find grid points
  I = 0;
	for(i = 0; i < n; i++) {
		k = i;

		for(j = 0; j < dim; j++) {
			l = k % samples[j];
			k /= samples[j];

			x[j] = min[j] + ((max[j] - min[j]) * l) / samples[j];
    }

    printf("[%2f, %2f, %2f]\n", x[0], x[1], x[2]);

    I += (*f)(closure_data, x);
    printf("i = %d, I = %2f\n\n", i, V/(i + 1) * I);
  }
  I *= V / n;

  free(x);

  return I;
}
