#ifndef __LINE_GRAPH_STRUCT_H__
#define __LINE_GRAPH_STRUCT_H__

#include "line_graph.h"

struct line_graph
{
	int vertex_count;
	int edge_pair_count;
};

typedef struct {
	int edge_pair_count;
	edge_pair_t *edge_pairs;

} vertex_entry_t;

static vertex_entry_t *get_vertex_entry(line_graph_t *G, int vertex)
{
	intptr_t p;
	vertex_entry_t *vertex_entries;

	assert(vertex < G->vertex_count);

	// Skip to vertex entry list
	p = (intptr_t)G;
	p += sizeof(line_graph_t);
	vertex_entries = (vertex_entry_t *)p;

	return vertex_entries + vertex;
}

#endif // #ifndef __LINE_GRAPH_STRUCT_H__
