#include "monte_carlo.h"

#include "util.h"

double integrate_monte_carlo(
  int dim,
  double (*f)(void *closure_data, double *x),
  double *min, double *max,
  int samples,
  void *closure_data)
{
  int i, j;
  double I, *x, V;

  x = malloc(sizeof(double) * dim);

  // Find volume
  V = 1;
  for(j = 0; j < dim; j++) {
    V *= max[j] - min[j];
  }

  I = 0;
  for(i = 0; i < samples; i++) {
    // Construct sample
    for(j = 0; j < dim; j++) {
      x[j] = frand(min[j], max[j]);
    }

    I += (*f)(closure_data, x);

    //printf("i = %d, I = %2g\n\n", i, V/(i + 1) * I);
  }

  I *= V/samples;

  free(x);

  return I;
}
