#ifndef __SPARSE_MATRIX_H__
#define __SPARSE_MATRIX_H__

typedef struct {
	int rows, cols, nnz, *i, *j;
	double *v;

} matrix_list_t;

matrix_list_t *matrix_list_create(int rows, int cols, int nnz);
void matrix_list_destroy(matrix_list_t *);

void matrix_list_set_submatrix(matrix_list_t *dst, matrix_list_t *src,
															 int i_offset, int j_offset, int elt_offset);


// TODO: column major form
typedef struct {
	int rows, cols, nnz, *beg, *cnt, *ind;
	double *val;
} matrix_rows_t;

matrix_rows_t *matrix_rows_create(int rows, int cols, int nnz);
void matrix_rows_destroy(matrix_rows_t *);

/**
 * Convert a sparse matrix from the "list" format to the "rows" format.
 */
matrix_rows_t *matrix_list_to_rows(matrix_list_t *);

#endif // #ifndef __SPARSE_MATRIX_H__
