#ifndef __TENSOR_FIELD_H__
#define __TENSOR_FIELD_H__

#include "point.h"
#include "tensor.h"

typedef struct tensor_field tensor_field_t;

// Constructors/destructor
tensor_field_t *tensor_field_create_grid(
  int dim,
  point_t origin, point_t spacing,
  int *size);
tensor_field_t *tensor_field_create_free(int dim, int count);

tensor_field_t *tensor_field_resize(tensor_field_t *, int new_count);

tensor_field_t *tensor_field_clone(tensor_field_t *);
void tensor_field_destroy(tensor_field_t *);

// Accessors
int tensor_field_dim(tensor_field_t *);
int tensor_field_count(tensor_field_t *);
point_t tensor_field_point(tensor_field_t *, int i);
tensor_t *tensor_field_tensor(tensor_field_t *, int i);

// Mutators
tensor_field_t *tensor_field_add(tensor_field_t *tf, point_t p, tensor_t *T);

// Find the limits of a tensor field
void tensor_field_extent(tensor_field_t *tf, point_t min, point_t max);

#endif // #ifndef __TENSOR_FIELD_H__
