#include "bent_weight.h"

coord_t pos[3][3] = {
  {-1, 0, 0},
  {0, 0, 0},
  {1, 0, 0}
};

bent_weight_options_t bent_opts = {
	1e1, // angle_weight
  8, //sigma
  16 * 1024 // expectation samples
};

weight_options_t weight_opts = {
  1.9,
  &bent_weight_expectation,
	&bent_opts,
	1
};

int main(int argc, char **argv)
{
	tensor_t *T[3];
	point_t p[3];
	int i, j, dim = 3;
	double w;

	srand(time(NULL));

	for(i = 0; i < 3; i++) {
		T[i] = tensor_create(dim);
		tensor_zero(T[i]);

		for(j = 0; j < dim; j++) {
			tensor_elt_set(T[i], j, j, 0.1);
		}

		p[i] = pos[i];
	}

	tensor_elt_set(T[0], 0, 0, 1);

	tensor_elt_set(T[1], 0, 0, 1);

	tensor_elt_set(T[2], 0, 0, 1);

	w = bent_weight_expectation(dim, &weight_opts, p, T);

	printf("w = %2g\n", w);

	return 0;
}
