#include "mask.h"

#define N (16)
#define TRIALS (8)

int main(int argc, char **argv)
{
	mask_t *m;
	int i, j;

	srand(time(NULL));

	m = mask_create(N);

	for(i = 0; i < N; i++) {
		mask_set(m, i, false);
	}

	mask_print(m);

	for(i = 0; i < TRIALS; i++) {
		j = rand() % N;
		printf("%d\n", j);
		mask_set(m, j, true);
		mask_print(m);
	}

	printf("count = %lu\n", (long unsigned int)mask_count_true(m));

	mask_destroy(m);

	return 0;
}
