#ifndef __WEIGHT_FILE_H__
#define __WEIGHT_FILE_H__

#include "weight_vector.h"
#include "weights.h"

typedef struct weight_file weight_file_t;

weight_file_t *weight_file_create(FILE *fp, int dimensionality);
weight_file_t *weight_file_open(FILE *fp);
void weight_file_close(weight_file_t *);

int weight_file_dimensionality(weight_file_t *);

void weight_file_write(weight_file_t *f, weight_vector_t *w);
weight_vector_t *weight_file_read(weight_file_t *f);

// Convenience functions for arrays of weight vectors
weight_vector_array_t *weight_vector_array_from_file(weight_file_t *);
weight_vector_array_t *weight_vector_array_from_file_name(const char *filename);

void weight_vector_array_to_file(weight_file_t *, weight_vector_array_t *);
void weight_vector_array_to_file_name(const char *filename, weight_vector_array_t *);

#endif // #ifndef __WEIGHT_FILE_H__
