#ifndef __WEIGHT_VECTOR_INTERNAL_H__
#define __WEIGHT_VECTOR_INTERNAL_H__

#include "weight_vector.h"
#include "affine.h"

struct weight_vector {
	int dim;

	/**
   * Neighbor positions
   */
	point_t pos[2];

	/**
   * Number of angles which 0...pi was discretized into
   */
	int angle_count;

  /**
   * The same, repeated
   */
  int *size;

	/**
   * 3D or 6D table of spline weights (angle_count to a side)
   */
	double *weights;
};

typedef struct {
	angle_t theta, phi;
} spherical_orientation_t;

#endif // #ifndef __WEIGHT_VECTOR_INTERNAL_H__
