#ifndef __WEIGHTS_H__
#define __WEIGHTS_H__

#include "tensor_field.h"
#include "line_graph.h"
#include "point.h"
#include "mask.h"

typedef struct weight_options weight_options_t;
struct weight_options {
	double neighborhood;
	
	// Weights assigned to contour going through 0-1-2
	// points[1] will always be the origin
	double (*weight)(int dim, weight_options_t *,
                   point_t points[3], tensor_t *tensors[3]);

	// Is not overwritten by any code within weighted_line_graph
	void *closure_data;

  // Whether to print helpful messages...
  int verbose;
};

extern const weight_options_t weight_options_defaults;

void weighted_line_graph(weight_options_t *opts, tensor_field_t *tf, mask_t *endpoints, line_graph_t *unweighted);
line_graph_t *weighted_neighborhood_line_graph(weight_options_t *opts, tensor_field_t *tf, mask_t *endpoints);



#endif // #ifndef __WEIGHTS_H__
