#include "sobel.h"
#include "conv.h"

static double sobelx_kernel_data[] = {-1, 0, 1, -2, 0, 2, -1, 0, 1};
static image_float_t sobelx_kernel = {3, 3, 3, sobelx_kernel_data};

static double sobely_kernel_data[] = {1, 2, 1, 0, 0, 0, -1, -2, -1};
static image_float_t sobely_kernel = {3, 3, 3, sobely_kernel_data};

void sobelx(image_float_t *I, image_float_t *dx)
{
	convolve(I, &sobelx_kernel, dx);
}

void sobely(image_float_t *I, image_float_t *dy)
{
	convolve(I, &sobely_kernel, dy);
}

void sobel(image_float_t *I, image_float_t *dx, image_float_t *dy)
{
	sobelx(I, dx);
	sobely(I, dy);
}
