#ifndef __CONTEXT_H__
#define __CONTEXT_H__

#include "point.h"
#include "affine.h"

typedef struct draw_context draw_context_t;

// Transformations
void draw_context_push_transform(draw_context_t *);
void draw_context_pop_transform(draw_context_t *);

void draw_context_scale(draw_context_t *, point_t);
void draw_context_scale_symm(draw_context_t *, coord_t);
void draw_context_translate(draw_context_t *, point_t);
void draw_context_rotate2(draw_context_t *, angle_t);

// Drawing

/**
 * Draw the unit circle
 */
void draw_context_circle(draw_context_t *);

// Drawing lines
void draw_context_line_begin(draw_context_t *, point_t);
void draw_context_line_add(draw_context_t *, point_t);
void draw_context_line_end(draw_context_t *);

/**
 * Set color
 */
void draw_context_color(draw_context_t *, float r, float g, float b);
void draw_context_color_alpha(draw_context_t *, float r, float g, float b, float a);
void draw_context_line_width(draw_context_t *, float);

// Total
void draw_context_finish(draw_context_t *);

#endif // #ifndef __CONTEXT_H__
