#ifndef __CONTEXT_INTERNAL_H__
#define __CONTEXT_INTERNAL_H__

#include "context.h"

typedef struct draw_context_vtable draw_context_vtable_t;

struct draw_context
{
	const draw_context_vtable_t *vtable;
};

struct draw_context_vtable {
	// Transforms
	void (*push_transform)(draw_context_t *);
	void (*pop_transform)(draw_context_t *);

	void (*scale)(draw_context_t *, point_t);
	void (*scale_symm)(draw_context_t *, coord_t);
	void (*translate)(draw_context_t *, point_t);
	void (*rotate2)(draw_context_t *, angle_t);

	// Drawings
	void (*circle)(draw_context_t *);

	void (*line_begin)(draw_context_t *, point_t);
	void (*line_add)(draw_context_t *, point_t);
	void (*line_end)(draw_context_t *);

	// Other
	void (*color)(draw_context_t *, float r, float g, float b);
	void (*color_alpha)(draw_context_t *, float r, float g, float b, float a);
	void (*line_width)(draw_context_t *, float w);
	void (*finish)(draw_context_t *);
};

#endif // #ifndef __CONTEXT_INTERNAL_H__
