#ifndef __DRAW_H__
#define __DRAW_H__

#include "tensor_field.h"
#include "line_graph.h"
#include "bundle.h"

typedef struct draw_options draw_options_t;
struct draw_options
{
	double line_width;
	double tract_line_width;

  double tensor_scaling;
  
  float background_color[3];
  float tensor_color[3];
  float line_graph_color[3];
	float path_color[3];

	bool shade_graph;
};

extern const draw_options_t draw_default_options;
extern const draw_options_t draw_grayscale_default_options;

#include "context.h"

void draw(draw_context_t *context,
					const draw_options_t *opts,
					tensor_field_t *tf,
					line_graph_t *G,
					bundle_t *paths);

void draw_space(const draw_options_t *opts,
								tensor_field_t *tf, bundle_t *paths,
								point_t min, point_t max);

#endif // #ifndef __DRAW_H__
