#include "ext.h"

#include "pdf.h"
#include "png.h"

#include <cairo.h>

static const char *get_ext(const char *filename)
{
	const char *c;

	for(c = filename + strlen(filename);
			c >= filename && *c != '.';
			c--);

	if(c == filename && *c != '.') {
		return NULL;
	}

	return c+1;
}

void draw_for_ext(
  const char *filename, int width, int height,
  const draw_options_t *opts,
  tensor_field_t *tf, line_graph_t *G, bundle_t *paths)
{
	const char *ext;

	ext = get_ext(filename);
	if(ext == NULL) {
		return;
	}

	if(strcmp(ext, "png") == 0) {
		draw_png(filename, width, height, opts, tf, G, paths);
	}
#ifdef CAIRO_HAS_PDF_SURFACE
	else if(strcmp(ext, "pdf") == 0) {
		draw_pdf(filename, width, height, opts, tf, G, paths);
	}
#endif
}
