#include "pdf.h"
#include "cairo.h"

#include <cairo.h>

#ifdef CAIRO_HAS_PDF_SURFACE

#include <cairo-pdf.h>

void draw_pdf(
  const char *filename, int width, int height,
  const draw_options_t *opts,
  tensor_field_t *tf, line_graph_t *G, bundle_t *paths)
{
  cairo_surface_t *surface;

	surface = cairo_pdf_surface_create(filename, width, height);

	printf("Drawing...\n");

  // Draw
  draw_cairo(surface, width, height, opts, tf, G, paths);

  // Cleanup
  cairo_surface_destroy(surface);
}

#endif
