#include "png.h"
#include "cairo.h"

void draw_png(const char *filename, int width, int height,
              const draw_options_t *opts,
              tensor_field_t *tf, line_graph_t *G, bundle_t *paths)
{
  cairo_surface_t *surface;

  // Allocate
  surface = cairo_image_surface_create(CAIRO_FORMAT_ARGB32, width, height);

	printf("Drawing...\n");

  // Draw
  draw_cairo(surface, width, height, opts, tf, G, paths);

	printf("Writing %s...\n", filename);

  // Write
  cairo_surface_write_to_png (surface, filename);

  // Cleanup
  cairo_surface_destroy(surface);
}
