#include "draw/png.h"
#include "tensor_field_parser.h"

int main(int argc, char **argv)
{
  FILE *f;
  tensor_field_t *tf;
  draw_options_t draw_opts;

  assert(argc == 3);

  // Read in tensor field
  f = fopen(argv[1], "r");
  if(f == NULL) {
		fprintf(stderr, "Could not read \"%s\"\n", argv[1]);
		return 1;
  }
  tf = tensor_field_from_file(f);
  fclose(f);

	if(tf == NULL) {
		fprintf(stderr, "Error reading tensor field file\n");
		return 1;
	}
	printf("Successfully read tensor field file\n");

  // Draw it!
  // TODO: make some of these options...
  draw_opts = draw_default_options;
  draw_opts.tensor_scaling = 4e-1;

  draw_png(argv[2], 480, 480, &draw_opts, tf, NULL);

  // Cleanup
	tensor_field_destroy(tf);

  return 0;
}
