#include "mask_io.h"

///////////////////// Read /////////////////////
mask_t *mask_from_file(FILE *fp)
{
	mask_t *m;
	char c;
	int n;

	m = mask_create(0);
	n = 0;

	while(1) {
		c = (char)fgetc(fp);
		if(feof(fp)) {
			break;
		}

		if(isspace(c)) {
			continue;
		}

		//printf("c = '%c' (%d)\n", c, (int)c);

		assert(c == '0' || c == '1');

		m = mask_resize(m, n+1);
		mask_set(m, n, c == '1');
		n++;
	}

	return m;
}

mask_t *mask_from_file_name(const char *filename)
{
	FILE *fp;
	mask_t *m;

	fp = fopen(filename, "r");
	if(fp == NULL) {
		return NULL;
	}

	m = mask_from_file(fp);

	fclose(fp);

	return m;
}


///////////////////// Write /////////////////////
void mask_write(FILE *fp, mask_t *m)
{
	int i, n;

	n = mask_size(m);
	for(i = 0; i < n; i++) {
		fputc(mask_get(m, i) ? '1' : '0', fp);
	}
}

void mask_write_file_name(const char *filename, mask_t *m)
{
	FILE *fp;

	fp = fopen(filename, "w+");
	if(fp == NULL) {
		return;
	}

	mask_write(fp, m);

	fclose(fp);
}
