#include "rect_endpoints.h"
#include "util.h"

mask_t *rect_endpoints(tensor_field_t *tf)
{
  int i, d, n, dim;
  point_t p;
  mask_t *endpoints;

  dim = tensor_field_dim(tf);
  n = tensor_field_count(tf);

  coord_t min[dim], max[dim];

  // Find rect bounds
  tensor_field_extent(tf, min, max);

  // Set endpoints to anything at the bounds
  endpoints = mask_create(n);

  for(i = 0; i < n; i++) {
    p = tensor_field_point(tf, i);

		mask_set(endpoints, i, false);
    for(d = 0; d < dim; d++) {
      if(p[d] == min[d] || p[d] == max[d]) {
				mask_set(endpoints, i, true);
        break;
      }
    }
  }

  return endpoints;
}
