#ifndef __TENSOR_FIELD_PARSER_H__
#define __TENSOR_FIELD_PARSER_H__

#include "tensor_field.h"

///////////////////// Read /////////////////////
typedef struct tensor_field_parser tensor_field_parser_t;

tensor_field_parser_t *tensor_field_parser_create();
void tensor_field_parser_destroy(tensor_field_parser_t *);

int tensor_field_parser_feed(tensor_field_parser_t *, int length, const char *data);

// Note: caller must free result
tensor_field_t *tensor_field_parser_end(tensor_field_parser_t *);

tensor_field_t *tensor_field_from_file(FILE *);
tensor_field_t *tensor_field_from_file_name(const char *);


///////////////////// Write /////////////////////
void tensor_field_write(FILE *, tensor_field_t *);
void tensor_field_write_file_name(const char *, tensor_field_t *);

#endif // #ifndef __TENSOR_FIELD_PARSER_H__
