#ifndef __GL_UTIL_HH__
#define __GL_UTIL_HH__

extern "C" {
#include "point.h"
}

static inline void gl_point(int dim, point_t p)
{
  if(dim == 2) {
    glVertex2f((float)p[0], (float)p[1]);
  }
  else if(dim == 3) {
    glVertex3f((float)p[0], (float)p[1], (float)p[2]);
  }
  else {
    UNSUPPORTED_DIMENSIONALITY(dim);
  }
}

static inline void gl_translate(int dim, point_t p)
{
  if(dim == 2) {
    glTranslatef((float)p[0], (float)p[1], 0);
  }
  else if(dim == 3) {
    glTranslatef((float)p[0], (float)p[1], (float)p[2]);
  }
  else {
    UNSUPPORTED_DIMENSIONALITY(dim);
  }
}


#endif // #ifndef __GL_UTIL_HH__
