#ifndef __GLMATRIX_HH__
#define __GLMATRIX_HH__

#include <wx/glcanvas.h>
#include <ostream>

class GLMatrix
{
public:
  double data[16];

  // Get/set matrices
  static GLMatrix get(GLenum which);
  static void set(GLenum which, const GLMatrix &M);

  // Building certain matrices
  static const GLMatrix identity;
  static GLMatrix rotation(double angle, double x, double y, double z);
  static GLMatrix translation(double x, double y, double z);

  // Elementwise access
  double *elt(int i, int j);
  const double *elt(int i, int j) const;

  // Performing math with this matrix
  void mult(double *prod, const double *v) const;
  void solve(double *x, const double *b) const;

  GLMatrix &operator *= (const GLMatrix &);

private:

};

GLMatrix operator * (const GLMatrix &, const GLMatrix &);
std::ostream &operator << (std::ostream &, const GLMatrix &);

#endif // #ifndef __GLMATRIX_HH__
