#include <wx/wx.h>

#include "model_canvas.hh"

class Frame: public wxFrame
{
public:
  Frame(const wxString &title, const wxPoint &pos, const wxSize &size);

  void OnQuit(wxCommandEvent &event);
  
  DECLARE_EVENT_TABLE()

private:
  ModelCanvas *canvas;
};

Frame::Frame(const wxString &title, const wxPoint &pos, const wxSize &size) :
  wxFrame(NULL, -1, title, pos, size)
{
  canvas = new ModelCanvas(this);  
}

void Frame::OnQuit(wxCommandEvent &event)
{
  Close(true);
}

BEGIN_EVENT_TABLE(Frame, wxFrame)
END_EVENT_TABLE()

class App: public wxApp
{
  virtual bool OnInit();
};

bool App::OnInit()
{
  wxString title = _("Some testing");
  Frame *frame = new Frame(title, wxPoint(50, 50), wxSize(640, 640));

  frame->Show(true);
  SetTopWindow(frame);

  return true;
}

IMPLEMENT_APP(App)
