#include "cross_product.h"


void crossprod3d(point_t dst, point_t u, point_t v)
{
	int dim;
	int i, j, k;

	dim = 3;

	for(k = 0; k < dim; k++) {
		i = (k+1) % dim;
		j = (k+2) % dim;

		dst[k] = u[i] * v[j];
		
		i = ((k-1) + dim) % dim;
		j = ((k-2) + dim) % dim;

		dst[k] -= u[i] * v[j];
	}
}

length_t crossprod3d_norm(point_t u, point_t v)
{
	int dim = 3;
	coord_t crossprod[dim];

	crossprod3d(crossprod, u, v);

	return point_l2_norm(dim, crossprod);
}
