#ifndef __MIN_SPLINE_H__
#define __MIN_SPLINE_H__

#include "spline.h"

typedef union precision precision_t;
union precision {
	int N;
	double epsilon;
};

typedef struct minimize_options minimize_options_t;
struct minimize_options {
	int max_iter;
	double tol;
	precision_t start_precision;

  int verbose;
	void (*error)(minimize_options_t *, int err, const char *msg);
	void *user_data;
};

extern const minimize_options_t minimize_options_default;

// Optimizes some function over the magnitudes of the derivative constraints
double spline_optimize_magnitudes(
  spline_t *spline,

	double (*objective)(void *closure_data, spline_t *s, precision_t e),
	void (*gradient)(void *closure_data, spline_t *s, int dim, double *g, precision_t e),
	int (*refine)(void *closure_data, precision_t *e),

	void *closure_data,
	minimize_options_t *opts);

#endif // #ifndef __MIN_SPLINE_H__
