#ifndef __SPLINE_CANVAS_HH__
#define __SPLINE_CANVAS_HH__

#include "model/model_canvas.hh"

extern "C" {
#include "spline.h"
}

class SplineCanvas: public ModelCanvas
{
public:
  SplineCanvas(
    wxWindow *parent,
    const wxPoint &pos = wxDefaultPosition, const wxSize &size = wxDefaultSize,
    const wxString &name = _("SplineCanvas"),
    const spline_t *init_spline = NULL, bool editable = true);

  virtual ~SplineCanvas();

  virtual void draw();

  void OnKeyDown(wxKeyEvent& event);

  DECLARE_EVENT_TABLE()

private:
  spline_t *spline;

  bool editable;

  // Drawing the spline proper
  static int spline_points_count;
  coord_t *spline_points;
  void draw_spline();
  void calculate_spline_points();

  // Drawing markers for knots
  static float marker_size;
  void draw_marker(int dim, point_t p);
  void draw_knots();
};

#endif // #ifndef __SPLINE_CANVAS_HH__
