#ifndef __SPLINE_SEGMENT_H__
#define __SPLINE_SEGMENT_H__

// TODO: generalize segment handling
typedef struct {
  int dim;
	point_t p0, m0, p1, m1;
} segment_t;

void spline_segment_get(segment_t *dst, spline_t *src, int i);
void spline_segment_get_backwards(segment_t *dst, spline_t *src, int i, point_t m0, point_t m1);

void spline_segment_point(segment_t *seg, param_t t, point_t p_t);
void spline_segment_derivative(segment_t *seg, param_t t, point_t dp_t);
void spline_segment_derivative2(segment_t *seg, param_t t, point_t ddp_t);

curvature_t spline_derivatives_curvature(int dim, point_t dp, point_t ddp);
curvature_t spline_segment_curvature(segment_t *seg, param_t t);


#endif // #ifndef __SPLINE_SEGMENT_H__
