#include "time.h"

#define MIN_CYCLE_TIME (1.0/60.0)

double usec()
{
	struct timeval tv;

	gettimeofday(&tv, NULL);

	return tv.tv_sec * 1e6 + tv.tv_usec;
}

static double last_idle = 0;

void idle()
{
	double diff;

	diff = usec() - last_idle;

	if(diff < MIN_CYCLE_TIME * 1e6) {
		usleep((useconds_t)(MIN_CYCLE_TIME * 1e6 - diff));
	}

	last_idle = usec();
}
