#include "nifti.h"

#include <nifti1_io.h>


int nifti_set_header(nifti_1_header *nifti_hdr, const char *filename)
{
	nifti_1_header *h;

	h = nifti_read_header(filename, NULL, 1);
	if(h == NULL) {
		return 1;
	}

	*nifti_hdr = *h;

	free(h);

	return 0;
}

void nifti_to_trk(trk_hdr_t *trk, nifti_1_header *nifti)
{
	int i;

	// Image dimensions
	for(i = 0; i < 3; i++) {
		trk->dim[i] = nifti->dim[i+1];
	}

	// Voxel dimensions
	for(i = 0; i < 3; i++) {
		trk->voxel_size[i] = nifti->pixdim[i+1];
	}

	// todo: qform_code, sform_code
	// may affect trk->voxel_size, trk->invert_[x,y,x], trk->swap[xy,yz,zx],
	// trk->image_orientation_patient, trk->pad[1,2]
}
