#ifndef __TRACT_FILE_H__
#define __TRACT_FILE_H__

#include "path.h"

typedef struct tract_file tract_file_t;

// open will be separate for each file type

int tract_file_close(tract_file_t *);

/////////////////// Status ///////////////////

//int tract_file_writeable(tract_file_t *);

/////////////////// Reading ///////////////////

// The number of tracts in the file
//   n: output argument
int tract_file_count(tract_file_t *, int *n);

// Which tract we're on
int tract_file_tell(tract_file_t *, int *i);

// Read a tract into 'dst', advance to the next track
path_t *tract_file_read(tract_file_t *);

// Check if we're at the end of the tract file
int tract_file_end(tract_file_t *);

/////////////////// Editing ///////////////////

// Append a tract to the file
int tract_file_append(tract_file_t *, path_t *);

// Complete all write operations
int tract_file_flush(tract_file_t *);

#endif // #ifndef __TRACT_FILE_H__
