#ifndef __TRACT_FILE_STRUCT_H__
#define __TRACT_FILE_STRUCT_H__

#include "tract_file.h"

typedef struct tract_file_vtable tract_file_vtable_t;

struct tract_file
{
	const tract_file_vtable_t *vtable;

	int writeable;

	int count;
	int i;

	FILE *fp;
};

struct tract_file_vtable
{
	path_t *(*read_tract)(tract_file_t *);
	int (*write_tract)(tract_file_t *, path_t *);

	int (*flush)(tract_file_t *);
	int (*end)(tract_file_t *);
	int (*close)(tract_file_t *);
};

// Constructor
void tract_file_init(tract_file_t *, const tract_file_vtable_t *, FILE *fp);

#endif // #ifndef __TRACT_FILE_STRUCT_H__
