#include "cli_util.h"


double cli_float_arg(int argc, char **argv,
										 const cli_t *cli, const argdef_t *def,
										 const char *value)
{
	int s;
	double v;

	s = sscanf(value, "%lg", &v);
	if(s != 1) {
		cli_error(cli, argc, argv, "Invalid value for %s: \"%s\"",
							def->value, value);
		exit(EX_USAGE);
	}

	return v;
}

unsigned int cli_uint_arg(int argc, char **argv,
													const cli_t *cli, const argdef_t *def,
													const char *value)
{
	int s;
	unsigned int u;

	s = sscanf(value, "%u", &u);
	if(s != 1) {
		cli_error(cli, argc, argv, "Invalid value for %s: \"%s\"",
							def->value, value);
		exit(EX_USAGE);
	}

	return u;
}
