#include "indices.h"

int sub2ind(int dim, const int *size, const int *sub)
{
	int i, ind, stride;

	ind = 0;
	stride = 1;
	for(i = dim - 1; i >= 0; i--) {
    assert(sub[i] < size[i]);

		ind += stride * sub[i];
		stride *= size[i];
	}

	return ind;
}

void ind2sub(int dim, const int *size, int ind, int *sub)
{
	int i;

	for(i = 0; i < dim; i++) {
		sub[i] = ind % size[i];
		ind /= size[i];
	}
}
