#ifndef __INTEGRAL_H__
#define __INTEGRAL_H__

typedef enum {
  INTEGRAL_SCHEME_ADAPTIVE_SIMPSONS,
  INTEGRAL_SCHEME_COMPOSITE_SIMPSONS

} integral_scheme_t;

double integrate_adaptive_simpsons(
  double (*f)(void *user_data, double x),
	double a, double b,
	double epsilon, unsigned int max_evals,
	void *user_data);

double integrate_composite_simpsons(
  double (*f)(void *user_data, double x),
	double a, double b,
	int intervals,
	void *user_data);

#endif // #ifndef __INTEGRAL_H__
