#ifndef __IO_H__
#define __IO_H__

// Endianness
static inline void noop_byte_order(void *p, int n)
{
}
void swap_byte_order(void *p, int n);

#ifdef BIG_ENDIAN

#define force_big_endian noop_byte_order
#define force_little_endian swap_byte_order

#else

#define force_big_endian swap_byte_order
#define force_little_endian noop_byte_order

#endif // #ifdef BIGENDIAN

// Read/write C datatypes
int32_t read_int32(FILE *fp);
void write_int32(FILE *fp, int32_t i);

float read_float(FILE *fp);
void write_float(FILE *fp, float f);

void read_floats(FILE *fp, int n, float *f);
void write_floats(FILE *fp, int n, float *f);

void read_doubles(FILE *fp, int n, double *d);
void write_doubles(FILE *fp, int n, double *d);

#endif // #ifndef __IO_H__
