#ifndef __PARALELL_H__
#define __PARALELL_H__

/**
 * Execute a closure in parallel.
 *
 * Each run of the closure is given an integer in [0, job_count).
 * No run is given the same integer twice.
 *
 * @arg worker_count Number of simultaneous jobs to run.
 *                   Values <= 0 will result in the use of a default value.
 */
int parallel_execute(int job_count, int worker_count,
										 int (*closure)(int job_i, void *closure_data),
										 void *closure_data);

#endif // #ifndef __PARALELL_H__
